﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

using System.Data.SqlClient;

namespace CSC330Project2
{
     public partial class CheckOut : BaseForm
     {
          private List<int> rooms = new List<int>();
          int selectedIndex;
          public CheckOut()
          {
               InitializeComponent();
               FillCombo();
          }

          private void FillCombo()
          {
               using (SqlConnection sqlConnection = new SqlConnection(connectionString))
               {
                    SqlCommand cmd = new SqlCommand("SELECT lastName, firstName, roomNumber FROM guestDB", sqlConnection);
                    sqlConnection.Open();
                    SqlDataReader sqlReader = cmd.ExecuteReader();
                    while (sqlReader.Read())
                    {
                         //READ
                         int roomNumber = Convert.ToInt32(sqlReader["roomNumber"]);
                         string name = sqlReader["firstName"].ToString() + " " + sqlReader["lastName"].ToString();
                         string show = "#" + roomNumber + " - " + name;
                         roomNum.Items.Add(show);
                         rooms.Add(roomNumber);
                    }
               }
          }

          private void button1_Click(object sender, EventArgs e)
          {
               this.Close();
          }

          private void button5_Click(object sender, EventArgs e)
          {
               // 0->fail 1->cancel 2->yes
               int success = 0;
               using (SqlConnection connection = new SqlConnection(connectionString))
               {
                    //READ
                    SqlCommand cmdR = new SqlCommand("SELECT guestId, lastName, firstName, roomNumber, totalCost FROM guestDB");
                    cmdR.CommandType = CommandType.Text;
                    cmdR.Connection = connection;
                    connection.Open();
                    SqlDataReader myReader = cmdR.ExecuteReader();
                    while (myReader.Read())
                    {
                         if (myReader["roomNumber"].ToString() == rooms[selectedIndex].ToString())
                         {
                             DialogResult dialogResult = MessageBox.Show("Name: " + myReader["firstName"].ToString() + " " + myReader["lastName"] + "\nTotal Cost: $" + myReader["totalCost"], "Bill", MessageBoxButtons.YesNo);
                             if (dialogResult == DialogResult.Yes)
                                 success = 2;
                             else
                                 success = 1;
                         }
                    }
               }

               if (success == 2)
               {
                    //DELETE
                    SqlConnection con = new SqlConnection(connectionString);
                    con.Open();
                    SqlCommand cmdD = new SqlCommand(@"DELETE FROM guestDB WHERE (roomNumber = '" + rooms[selectedIndex] + "')", con);
                    cmdD.ExecuteNonQuery();
                    con.Close();

                    using (SqlConnection sqlConnection = new SqlConnection(connectionString))
                    {
                        //CHANGE
                        SqlCommand sqlCmd = new SqlCommand("UPDATE roomDB SET isTaken = 0 Where roomNumber = @rn", sqlConnection);
                        sqlCmd.Parameters.AddWithValue("@rn", rooms[selectedIndex]);
                        sqlConnection.Open();
                        SqlDataReader sqlReader = sqlCmd.ExecuteReader();
                    }
                    MessageBox.Show("Guest checked out.");
                    this.Close();
               }
               else if (success == 0)
                    MessageBox.Show("The record does not exist.");
               
                    
          }

          private void roomNum_SelectedIndexChanged_1(object sender, EventArgs e)
          {
               if (roomNum.SelectedIndex != -1)
               {
                    selectedIndex = roomNum.SelectedIndex;
               }
          }
     }
}
