﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Data.SqlClient;

namespace CSC330Project2
{
    public partial class CreateAdmin : BaseForm
    {
        public CreateAdmin()
        {
            InitializeComponent();
        }

        private void help_Click(object sender, EventArgs e)
        {
            MessageBox.Show("An admin account must be created before the system is used.", "Info", MessageBoxButtons.OK, MessageBoxIcon.Question);
        }

        private void createAccount_Click(object sender, EventArgs e)
        {
            if (PasswordBox.Text != VerifyPassword.Text)
            {
                MessageBox.Show("Password does not match.","Info",MessageBoxButtons.OK,MessageBoxIcon.Error);
            }
            else
            {
                 //Encrypt password field
                 byte[] data = System.Text.Encoding.ASCII.GetBytes(PasswordBox.Text);
                 data = new System.Security.Cryptography.SHA256Managed().ComputeHash(data);
                 String hash = System.Text.Encoding.ASCII.GetString(data);
                 
                 using (SqlConnection connection = new SqlConnection(connectionString))
                 {
                      //WRITE
                      SqlCommand cmd = new SqlCommand("INSERT INTO [Table] (username, password, type) VALUES (@username, @password, @type)");
                      //Table is reserved word -> [Table] instead of Table
                      cmd.CommandType = CommandType.Text;
                      cmd.Connection = connection;
                      cmd.Parameters.AddWithValue("@username", setUserName.Text);
                      cmd.Parameters.AddWithValue("@password", hash);
                      cmd.Parameters.AddWithValue("@type", "admin");
                      connection.Open();
                      cmd.ExecuteNonQuery();

                      //READ
                      SqlCommand cmd2 = new SqlCommand("SELECT userID, username FROM [Table]");
                      cmd2.CommandType = CommandType.Text;
                      cmd2.Connection = connection;
                      SqlDataReader myReader = cmd2.ExecuteReader();
                      if (myReader.Read())
                      {
                           MessageBox.Show("Saved to database...\nUsername: " + myReader["username"].ToString());
                      }
                 }
                 
            }
            this.Close();
        }

    }
}
