﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

using System.Data.SqlClient;

namespace CSC330Project2
{
     public partial class NewGuest : BaseForm
     {
          //Make list of rooms (new object)
          private List<Room> rooms = new List<Room>();
          int selectedRoom;

          public NewGuest()
          {
               InitializeComponent();
               FillCombo();
          }

          private void FillCombo()
          {
               using (SqlConnection sqlConnection = new SqlConnection(connectionString))
               {
                    SqlCommand cmd = new SqlCommand("SELECT roomNumber, roomType, roomCost, isTaken FROM roomDB",sqlConnection);
                    sqlConnection.Open();
                    SqlDataReader sqlReader = cmd.ExecuteReader();
                    while (sqlReader.Read())
                    {
                        bool isTaken = false;
                        string temp = sqlReader["isTaken"].ToString();
                        if (temp == "" || temp == "False")
                        {
                            isTaken = false;
                        }
                        else
                        {
                            isTaken = true;
                        }

                        if (!isTaken)
                        {
                              //READ
                              int roomNumber = Convert.ToInt32(sqlReader["roomNumber"]);
                              string roomType = sqlReader["roomType"].ToString();
                              double roomCost = Convert.ToDouble(sqlReader["roomCost"]);
                              string formattedRoomCost = String.Format("{0:0.00}", roomCost);

                              string itemStr = "#" + roomNumber + " - " + roomType + " - $" + formattedRoomCost;
                              comboBox1.Items.Add(itemStr);


                              Room newRoom = new Room();
                              newRoom.RoomNumber = roomNumber;
                              newRoom.RoomType = roomType;
                              newRoom.RoomCost = roomCost;
                              rooms.Add(newRoom);
                         }
                    }
               }
          }

          private void button2_Click(object sender, EventArgs e)
          {
              this.Close();
          }

          private void button1_Click(object sender, EventArgs e)
          {
              if (rooms.Count != 0)
              {
                  using (SqlConnection sqlConnection = new SqlConnection(connectionString))
                  {

                      SqlCommand cmd = new SqlCommand("INSERT INTO guestDB (lastName, firstName, address, email, arrivalDate, leaveDate, numberOfNights, roomType, roomNumber, totalCost) VALUES (@lastName, @firstName, @address, @email, @arrivalDate, @leaveDate, @numberOfNights, @roomType, @roomNumber, @totalCost)");
                      cmd.Connection = sqlConnection;
                      cmd.Parameters.AddWithValue("@lastName", textBox1.Text);
                      cmd.Parameters.AddWithValue("@firstName", textBox2.Text);
                      cmd.Parameters.AddWithValue("@address", textBox3.Text);
                      cmd.Parameters.AddWithValue("@email", textBox4.Text);
                      cmd.Parameters.AddWithValue("@arrivalDate", textBox5.Text);
                      cmd.Parameters.AddWithValue("@leaveDate", textBox6.Text);
                      cmd.Parameters.AddWithValue("@numberOfNights", textBox7.Text);
                      cmd.Parameters.AddWithValue("@roomType", rooms[selectedRoom].RoomType);
                      cmd.Parameters.AddWithValue("@roomNumber", rooms[selectedRoom].RoomNumber);
                      cmd.Parameters.AddWithValue("@totalCost", rooms[selectedRoom].RoomCost * Convert.ToInt32(textBox7.Text));
                      sqlConnection.Open();

                      cmd.ExecuteNonQuery();
                  }
                  MessageBox.Show("Guest has been added.");

                  using (SqlConnection sqlConnection = new SqlConnection(connectionString))
                  {
                      //CHANGE
                      SqlCommand sqlCmd = new SqlCommand("UPDATE roomDB SET isTaken = 1 Where roomNumber = @rn", sqlConnection);
                      sqlCmd.Parameters.AddWithValue("@rn", rooms[selectedRoom].RoomNumber);
                      sqlConnection.Open();
                      SqlDataReader sqlReader = sqlCmd.ExecuteReader();
                  }
                  this.Close();
              }
          }

          private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
          {
               if (comboBox1.SelectedIndex != -1)
               {
                    selectedRoom = comboBox1.SelectedIndex;
               }
                    
          }
     }
}
