﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

using System.Data.SqlClient;

namespace CSC330Project2
{
     public partial class NewOrder : BaseForm
     {
          private Order order = new Order();
          private List<Item> menu = new List<Item>();
          //When clicking on button, the listbox selection becomes -1: fix
          private int saveSelectionValue = 0;
          public NewOrder()
          {
               InitializeComponent();
               
               Fillcombo();
          }

          void Fillcombo()
          {   
              using (SqlConnection sqlConnection = new SqlConnection(connectionString))
              {
                  SqlCommand sqlCmd = new SqlCommand("SELECT foodName, foodCost FROM menuDB", sqlConnection);
                  sqlConnection.Open();
                  SqlDataReader sqlReader = sqlCmd.ExecuteReader();

                  while (sqlReader.Read())
                  {
                       double itemCost = Convert.ToDouble(sqlReader["foodCost"]);
                       string itemName = sqlReader["foodName"].ToString();
                       string iC = String.Format("{0:0.00}", itemCost);

                       string itemStr = itemName + " - " + iC;
                       comboBox1.Items.Add(itemStr);
                       //Each item is aded to the menu, accessible by it's index.
                       menu.Add(new Item(itemCost, itemName));
                  }

                  sqlReader.Close();
              }

              using (SqlConnection sqlConnection = new SqlConnection(connectionString))
              {
                   SqlCommand sqlCmd = new SqlCommand("SELECT roomNumber FROM guestDB", sqlConnection);
                   sqlConnection.Open();
                   SqlDataReader sqlReader = sqlCmd.ExecuteReader();

                   while (sqlReader.Read())
                   {
                        roomNum.Items.Add(sqlReader["roomNumber"]);
                   }

                   sqlReader.Close();
              }
              
          }

          private void button2_Click(object sender, EventArgs e)
          {
              this.Close();
          }

          private void listBox1_SelectedIndexChanged(object sender, EventArgs e)
          {
               //Ignore unselection
               if (listBox1.SelectedIndex != -1)
                    saveSelectionValue = listBox1.SelectedIndex;
          }

          private void button3_Click(object sender, EventArgs e)
          {
               if (roomNum.Text == "")
               {
                    MessageBox.Show("Please enter a room number.");
               }
               else 
               {
                    order.RoomNumber = Convert.ToInt32(roomNum.Text);
                    if (order.display())
                    {
                         using (SqlConnection sqlConnection = new SqlConnection(connectionString))
                         {
                              SqlCommand sqlCmd = new SqlCommand("UPDATE guestDB SET totalCost += @tc Where roomNumber = @rn", sqlConnection);
                              sqlCmd.Parameters.AddWithValue("@tc", order.totalPrice());
                              sqlCmd.Parameters.AddWithValue("@rn", order.RoomNumber);
                              sqlConnection.Open();
                              SqlDataReader sqlReader = sqlCmd.ExecuteReader();
                         }
                         MessageBox.Show("Your order has been processed.");
                    }
               }
          }

          private void button1_Click(object sender, EventArgs e)
          {
               if (comboBox1.SelectedIndex != -1)
               {
                    listBox1.Items.Add(comboBox1.Text);
                    order.add(menu[comboBox1.SelectedIndex]);
               }
          }

          private void button4_Click(object sender, EventArgs e)
          {
               if (listBox1.SelectedIndex != -1)
               {
                    order.remove(saveSelectionValue);
                    for (int i = listBox1.SelectedIndices.Count - 1; i >= 0; i--)
                    {
                         listBox1.Items.RemoveAt(listBox1.SelectedIndices[i]);
                    }
               }
          }
     }
}
